package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.TmstruckWeightResult;
import com.steerinfo.framework.mapper.IBaseMapper;
import java.math.*;
import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

@Mapper
public interface TmstruckWeightResultMapper extends IBaseMapper<TmstruckWeightResult, BigDecimal> {

    //查询最大主键Id
    @Select("select seq_tmstruck_weight_result.nextval from dual")
    BigDecimal selectMaxId();

    // 得到计重实绩主键id
    BigDecimal getWeightTaskResultId(Map<String,Object>mapValue);

    // 得到汽车衡id
    BigDecimal getTruckCalculateId(String resultCalculateNumber);

    List<Map<String,Object>> selectWzInputId();

    int updateWzInputId(BigDecimal wzInputId);

    BigDecimal getWeightTaskResultId(String orderNumber);

    Integer updateTruckWeightResult(Map<String, Object> mapValue);

    Integer updateTruckWeightResultGross(Map<String, Object> mapValue);

    //通过运输订单号 查询实绩Id、总实绩ID
    Map<String, Object> selectTotalIdByOrderNo(Map<String, Object> map);

    //通过运输订单号 和物资ID 查询实绩ID
    Map<String, Object> selectResultIdByOrderNoAndMaterialId(Map<String, Object> map);

    //通过汽车衡编号查询汽车衡ID
    Integer selectTruckCalculateId(String truckCalculateNumber);

    //通过运输订单号查询计量实绩Id 条件 路段顺序号 和 净重
    Map<String, Object> selectWeightIdByOrderId(Map<String, Object> map);

    //通过订单Id查询还没有净重的计量实绩
    Integer selectNoNetWeightResult(String orderNumber);

    //查询采购订单信息
    Map<String, Object> getPurOrderMesToKD(String orderNumber);

    //查询采购内转总厂到老区的订单信息
    Map<String, Object> get20PurOrderMesToKD(String orderNumber);
}