package com.test;

import com.steerinfo.dil.util.Log4jUtils;
import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import org.apache.axis.encoding.XMLType;
import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;
import org.dom4j.io.OutputFormat;
import org.dom4j.io.XMLWriter;
import org.hibernate.mapping.Array;
import org.junit.Test;

import javax.xml.rpc.ParameterMode;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.logging.Logger;

/**
 * @ author    :TXF
 * @ time      :2022/2/10 11:05
 */

public class Test2 {
    @Test
    public void test() {
        try {
            // 创建一个Document实例
            Document doc = DocumentHelper.createDocument();

            // 添加根节点
            Element root = doc.addElement("root");

            // 在根节点下添加第一个子节点
            Element oneChildElement = root.addElement("person").addAttribute("attr", "root noe");
            oneChildElement.addElement("people")
                    .addAttribute("attr", "child one")
                    .addText("person one child one");
            oneChildElement.addElement("people")
                    .addAttribute("attr", "child two")
                    .addText("person one child two");

            // 在根节点下添加第一个子节点
            Element twoChildElement = root.addElement("person").addAttribute("attr", "root two");
            twoChildElement.addElement("people")
                    .addAttribute("attr", "child one")
                    .addText("person two child one");
            twoChildElement.addElement("people")
                    .addAttribute("attr", "child two")
                    .addText("person two child two");

            // xml格式化样式
            // OutputFormat format = OutputFormat.createPrettyPrint(); // 默认样式

            // 自定义xml样式
            OutputFormat format = new OutputFormat();
            format.setIndentSize(2);  // 行缩进
            format.setNewlines(true); // 一个结点为一行
            format.setTrimText(true); // 去重空格
            format.setPadText(true);
            format.setNewLineAfterDeclaration(false); // 放置xml文件中第二行为空白行
            System.out.println(doc.asXML());
            // 输出xml文件
            XMLWriter writer = new XMLWriter(new FileOutputStream("E:\\asd.xml"), format);
            writer.write(doc);
            System.out.println("dom4j CreateDom4j success!");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static String asXmlDate(List<String> dataList) {
        // 创建一个Document实例
        Document doc = DocumentHelper.createDocument();
        // 添加根节点
        Element table = doc.addElement("table");
        //添加第子节点
        table.addElement("rowCount").addText("1");
        table.addElement("headCount").addText("9");
        Element head = table.addElement("head");
        //添加body下的r1下的子节点
        Element r1 = table.addElement("body").addElement("r1");
        //添加head的子节点
        for (int i = 0; i < dataList.size(); i++) {
            head.addElement("h" + (i + 1)).addText(dataList.get(i));
            r1.addElement("r1c" + (i + 1)).addText(dataList.get(i));
        }
        return doc.asXML();
    }

    public static String invokRemoveWSDLByAxis(String reqXML, String endPoint) {
        String responseXML = "";
        Service service = new Service();
        try {
            Call call = (Call) service.createCall();
            call.setTargetEndpointAddress(endPoint);
            call.setOperationName(new javax.xml.namespace.QName("http://webservice.app.facade.jjboom.custom.eas.kingdee.com", "transferEASInterfaceMethod"));
            call.addParameter("username", XMLType.XSD_STRING, ParameterMode.IN);
            call.setReturnType(XMLType.XSD_STRING);
            responseXML = (String) call.invoke(new Object[]{reqXML, "weighSoucNew"});
        } catch (Exception e) {
            e.printStackTrace();
        }
        return responseXML;
    }

    @Test
    public void test4() {
        ArrayList<String> list = new ArrayList<>();
        for (int i = 1; i < 10; i++) {
            list.add(i + "");
        }
        String testXml = asXmlDate(list);
        System.out.println(testXml);
    }

    @Test
    public void test5(){
        // 创建一个Document实例
        Document doc = DocumentHelper.createDocument();
        // 添加根节点
        Element requests = null;
        try {
            requests = doc.addElement("requests");
        } catch (Exception e) {
            e.printStackTrace();
        }
        //添加第子节点
        Element request = requests.addElement("request");
        request.addElement("TypeID").addText("PUR");               //采购订单类型
        request.addElement("FNumber").addText("1");              //磅单号
        request.addElement("FBizDate").addText("2");             // 净重时间
        request.addElement("Carnumber").addText("3");            //车牌号
        request.addElement("FTransportOrgID").addText("4");
        request.addElement("FGrossScaleID").addText("1");        //毛重汽车衡
        request.addElement("FTareScaleID").addText("1");         //皮重汽车衡
        request.addElement("FGrossWeight").addText("1");         //毛重时间
        request.addElement("FTareWeight").addText("1");          //皮重
        request.addElement("FGrossPoundTime").addText("1");      //毛重时间
        request.addElement("FTarePoundTime").addText("1");       //皮重时间
        request.addElement("FSourceBillID").addText("1");        //采购订单号
        request.addElement("FSourceBillEntryID").addText("1");   //分录ID
        request.addElement("FNetWeight").addText("1");           //净重
        request.addElement("FIncidental").addText("0");         //扣杂
        request.addElement("FLastNetWeight").addText("1");     //最后净重
        request.addElement("FDescription").addText("");       //备注

        System.out.println(doc.asXML());

    }
}
